/**
 ** $Id: patchlevel.h,v 1.28 1994/06/22 15:08:26 alden Exp $
 **
 ** $Log: patchlevel.h,v $
 ** Revision 1.28  1994/06/22  15:08:26  alden
 ** Release 3.3PL2 22-June-94
 **
 ** Revision 1.27  1994/06/17  12:52:32  alden
 ** Release 3.3beta6PL2 17-June-94
 **
 ** Revision 1.26  1994/06/16  21:08:35  alden
 ** Release 3.3beta5PL2 17-June-94
 **
 ** Revision 1.25  1994/06/16  13:51:18  alden
 ** Release 3.3beta4PL2
 **
 ** Revision 1.24  1994/06/08  14:14:39  alden
 ** Release 3.3beta3PL2 08-June-94
 **
 ** Revision 1.23  1994/05/02  19:22:45  alden
 ** Release 3.3beta1PL2 02-May-94
 **
 ** Revision 1.22  1994/03/08  23:15:51  alden
 ** Release 3.3PL1 08-Mar-94
 **
 ** Revision 1.21  1994/02/20  19:08:46  alden
 ** Release 3.3alphaPL1 20-Feb-94
 **
 ** Revision 1.20  1994/02/04  23:40:21  alden
 ** Release 3.3PL0 04-Feb-94
 **
 ** Revision 1.19  1994/01/04  01:36:32  alden
 ** Release 3.3beta8PL0 03-Jan-93
 **
 ** Revision 1.18  1993/12/22  00:58:26  root
 ** Release 3.3beta7PL0 21-Dec-93
 **
 ** Revision 1.17  1993/12/21  23:52:38  alden
 ** Release 3.3beta6PL0 21-Dec-93
 **
 ** Revision 1.16  1993/11/29  19:18:23  alden
 ** Release 3.3beta5PL0 29-Nov-93
 **
 ** Revision 1.15  1993/11/19  21:07:27  root
 ** Release 3.3beta4PL0 19-Nov-93
 **
 ** Revision 1.14  1993/11/12  01:23:58  alden
 ** Release 3.3beta3PL0 11-Nov-93
 **
 ** Revision 1.13  1993/11/10  18:08:59  alden
 ** Release 3.3beta2PL0 10-Nov-93
 **
 ** Revision 1.12  1993/10/26  19:17:56  alden
 ** Release 3.3betaPL0 26-Oct-93
 **
 ** Revision 1.10  1993/10/13  21:01:06  root
 ** Release 3.3alphaPL0 13-Oct-93
 **
 ** Revision 1.9  1993/06/05  18:35:24  alden
 ** Release 3.2PL1 05-Jun-93
 **
 ** Revision 1.8  1993/05/17  20:46:53  alden
 ** Release 3.2PL0 17-May-93
 **
 ** Revision 1.7  1993/05/11  18:30:07  alden
 ** Release 3.2betaPL7 11-May-93
 **
 ** Revision 1.6  1993/05/11  00:05:45  alden
 ** Release 3.2betaPL6 10-May-93
 **
 ** Revision 1.5  1993/05/05  18:44:01  root
 ** Release 3.2betaPL5 05-May-93
 **
 ** Revision 1.4  1993/05/05  00:03:45  alden
 ** Release 3.2alphaPL4 04-May-93
 **
 ** Revision 1.3  1993/04/20  00:59:22  alden
 ** Release 3.2betaPL3 19-Apr-93
 **
 ** Revision 1.2  1993/04/17  23:00:46  alden
 ** Release 3.2alphaPL2 17-Apr-93
 **
 ** Revision 1.1  1993/03/28  19:37:55  alden
 ** Initial revision
 **
 **
 ** 3.3pl2
 **     Fixed bug in parse_entry() which caused the message-id to be ignored
 **         if there was a timestamp in the entry (it would then use the
 **         history file to get the message-id  :-)
 **         --per@erix.ericsson.se (Per Hedeland)--
 **     Modified Makefile so on an install it first moves the old binary to
 **         binary.old and then installs the new one
 **         --newsmaster@ucs.cam.ac.uk (John Line)--
 **     Fixed bug in "links" which used "ps -e" on Sys 5 based machines, know
 **         it uses "ps -ef"
 **         --lindholm@ucs.ubc.ca (George Lindholm)--
 **     INT is ignored if nntplink was started with "links" -- therefore there
 **         was no clean way to kill off a one-shot mode reading from the
 **         batchfile.  INT is now the same as TERM, and HUP took over the
 **         rewrite purpose of INT.  :-)
 **     Split logfile and funnel file defaults into two different parameters
 **         in dist_conf.h (note that they both share the "-F" option to change
 **         their default)
 **         --per@erix.ericsson.se (Per Hedeland)--
 **     Modified "linkinfo" so you can just specify the batchfile name for the
 **         site you want info to and it will tack on the batchdir to find the
 **         link datafile
 **         --vato@csv.warwick.ac.uk (Ian Dickinson)--
 **     Modified "links" to cache the result of the "ps" output
 **         --vato@csv.warwick.ac.uk (Ian Dickinson)--
 **     Modified comment processing code in "links" to be a little faster
 **         --scott@dsg.tandem.com (Scott Mueller)--
 **     In send_news(), if send_ihave_msg() returned NULL, send_news() would
 **         assume failure, close connection and return.  Now it checks the
 **         code and if it is ERR_NOFILE_CONT or ERR_NOMSGID it skips to the
 **         next article.
 **     Added code to prevent user from specifying "-o" and either "-R" or "-M"
 **     write_batchentry() occasionally tried to deref a null pointer
 **         (Article.mesgid could be null) -- now it handles it properly
 **         --jgreco@ns.sol.net (Joe Greco)--
 **     nntplink didn't close down the connection gracefully if you used the
 **         "-o" option, now it does
 **         --tale@uunet.uu.net (David C Lawrence)--
 **     Modified links so it doesn't use "kill -0" anymore, instead it uses
 **         ps and greps for the pid and site -- not perfect, but I don't
 **         know of any other way
 **     Modified links so it handles the -b and -B options the same way
 **         nntplink does
 **         --per@erix.ericsson.se (Per Hedeland)--
 **     Modified log_stats() so it now calls write_link_datafile() after
 **         any modifications are done to the batchfile
 **     Fixed close_connection() so it just returns if their isn't already
 **         a connection open
 **     setsid() doesn't close 0, 1 or 2 if the process was started without
 **         a controlling terminal -- so we go ahead and close them anyway.
 **         --tale@uunet.uu.net (David C Lawrence)--
 **     Modified postconf.h so it redefines NULL after including stdlib.h
 **         --peirce@mickey.acs.wmich.edu--
 **     Modified rewrite_batchfile() so it removes <bfile.tmp> if it has
 **         problems creating it
 **         --tale@uunet.uu.net (David C Lawrence)--
 **     Replace an empty if/then clause with a null
 **         --fletcher@cs.utexas.edu (Fletcher Mattox)--
 **     New copyright message - much less restrictive
 **     Removed extraneous check in name_to_address()
 **         --anders@ifi.uio.no< (Anders Ellefsrud)--
 **         --peng@pirates.cs.swt.edu (Wuxu Peng)--
 **
 ** 3.3pl1
 **     Don't turn debugging on if fopen(debug_file, "a") fails
 **         --leres@ee.lbl.gov (Craig Leres)--
 **     Replaced '-c' (clear_batchfile) with '-M' (move batchfile) and
 **         '-R' (rewrite batchfile) -- moved old '-R' option to '-T'
 **     Fixed problem whereby I was relying on HAVE_SYSLOG_H to not be defined
 **         if FAKESYSLOG is defined
 **         --tale@uunet.uu.net (David C Lawrence)--
 **     Modify "links" to use "shlock"
 **         --andrew@werple.apana.org.au (Andrew Herbert)--
 **     Added some mods for NetBSD
 **         --andrew@werple.apana.org.au (Andrew Herbert)--
 **     Fixed several (d)logmsg() calls which were missing Host.sysname
 **     Replaced sleep_fail() routine with fail() routine -- now fail() has
 **         an extra argument specifying how long to sleep
 **         
 **
 ** 3.3
 **     Fixed bug whereby if nntplink exited due ot an "exit timeout", it
 **         didn't update the PID in the datafile
 **         --Chris.Schmidt@germany.eu.net--
 **     Complain about arguments after the sitename
 **         --leres@ee.lbl.gov (Craig Leres)--
 **     Socket/Connect errors are now logged with name==Host.sysname, instead
 **         of name==remote_server (== Host.name)
 **         --cross@cs.tu-berlin.de (Carsten Rossenhoevel)--
 **     Fixed mmap() call so it now works with BSDI
 **         --wolf@oleane.net (Christophe Wolfhugel)--
 **     Allow ":" to be the seperator character for the password file
 **         --mskucher@nic.hookup.net (Murray S. Kucherawy)--
 **     Sleep for 60 seconds if authorization fails -- this way we only log
 **         an error once/minute instead of once/second
 **     Remove all trailing "\n" from syslog() messages -- it is optional,
 **         however, some OS's seem to add one no matter what
 **     Fixed bug in log_stats() where it was ignoring the return code from
 **         get_next_art()
 **     Remove "include/config.h" when doing a "distclean"
 **         --kieber@irz301.inf.tu-dresden.de (Ulf Kieber)--
 **     Added a missing "#" to links.raw
 **         --sjr@afterlife.ncsc.mil (Stephen J. Roznowski)--
 **     Fixed bug in fixman whereby we could grep the wrong thing
 **         --kieber@irz301.inf.tu-dresden.de (Ulf Kieber)--
 **     Changed the meaning of the "-f" option (check man page)
 **     Fixed bug whereby articles weren't being either saved or junked
 **         if the remote site continually sent 436
 **         --ccteakle@cc.uq.oz.au (Chris Teakle)--
 **     History file needs to be closed each time a HUP signal is sent
 **         --cross@cs.tu-berlin.de (Carsten Rossenhoevel)--
 **     If nntplink needs to lookup the timeid from the history file, and it
 **         fails, then nntplink would just loop -- now it just assumes that
 **         timeid is 0 if it can't be found
 **         --cross@cs.tu-berlin.de (Carsten Rossenhoevel)--
 **     Moved clearerr(rmt_wr_fp) before the call to close_connection in
 **         remote.c -- needed for Solaris2.2
 **         --cross@cs.tu-berlin.de (Carsten Rossenhoevel)--
 **     Replaced "Host.name" with "Host.sysname" in fail(), dlogmsg() and
 **         logmsg() calls
 **         --cross@cs.tu-berlin.de (Carsten Rossenhoevel)--
 **     Fixed bug in links script which prevented the script from restarting
 **         connections when they weren't in the ps output
 **         --ramey@csc.ti.com (Joe Ramey)--
 **     Added new version of links.pl with "clean" option -- NOTE THAT THIS
 **         has not been tested -- use perl version at your own risk!!!  :-)
 **         --wolf@grasp.insa-lyon.fr (Christophe Wolfhugel)--
 **     Renamed NNTPLINK_LOGLEVEL to NNTPLINK_LOGFACILITY
 **         --rcfa@cubiculum.com (Ronald C.F. Antony)--
 **     Fixed bug in read_reply() when EINTR is received during select(),
 **         it would continue on to the fb_readline() -- if the remote end
 **         is extremely slow, then you can block indefinitely -- now if
 **         select() receives EINTR, then we close_connection() and return.
 **     Fixed update_link_datafile() so it doesn't ignore TERM signal -- now
 **         it exits if TERM is received
 **     Forgot to do a "shift" in the "links" shell script
 **         --per@erix.ericsson.se (Per Hedeland)--
 **     Modified Makefile so it installs the "links" program
 **         --per@erix.ericsson.se (Per Hedeland)--
 **     Fixed a couple of typos in the nntplink man page
 **         --per@erix.ericsson.se (Per Hedeland)--
 **     Renamed "extra" subdirectory to "support"
 **     Added man page for links-list, moved all man pages into man subdir
 **     Rewrote "links" to include "cleanbatch" functionality -- now you only
 **         have to worry about one script which does everything  :-)
 **     Fixed by which caused nntplink to log bogus elapsed time values
 **         (close_connection() was getting called twice in a row)
 **     Added "clear" and "abort" options and rewrote "boot" option in
 **         links.raw and links.pl
 **     Added "-U" to tell nntplink to use <batchfile.nntp> instead of
 **         <batchfile.pid>
 **     Added the ability to start/stop debugging by sending the signal
 **         SIGUSR2 to nntplink
 **     Modified update_batchfile() so if the kill() returns an error, it
 **         keeps trying up to MAX_NAPTIME before giving up and exiting
 **     Added a new "links" program written in Perl
 **         --wolf@grasp.insa-lyon.fr (Christophe Wolfhugel)--
 **     Fixed "-c <n>" so it really does rewrite the batchfile after <n>
 **         articles have been offered to the remote site
 **     Fixed nntplink so it handles unexpected connection closings much
 **         nicer now (it simply accepts the closure as a "failure" and
 **         gets on with its life. :-)
 **     Changed all occurrences of log() to logmsg()
 **     Removed "#ifdef _AIX" -- hoping _ALL_SOURCE takes care of it
 **     Fixed bug in update_batchfile() that sometimes didn't save the
 **         current article
 **     Only print "pid in datafile has changed" message if in debug mode,
 **         otherwise just go ahead and exit()
 **     Added "-I" option to nntplink -- This tells nntplink to ignore the pid
 **         found in the datafile when starting up -- useful when starting
 **         nntplink after a crash/reboot
 **     Added NNTPLINK_LOGLEVEL to conf.h -- this allows you to override the
 **         default facility used in syslog()'ing error messages
 **     Added "boot" option to links -- This is the same as "start", except
 **         it also passes the "-I" option to nntplink
 **     Added "agefunnel" option to links -- This is the same as "age", except
 **         it also ages the funnel file
 **     Modified nntplink so it handles INN created logfiles and funnel
 **         files (used to only deal with funnel files) -- this forced
 **         me to add a new input mode "funnel"
 **     Modified "cleanbatch" so it starts nntplink processes running in
 **         the background
 **     Modified "cleanbatch" so it locks on each site, instead of locking
 **         the whole script
 **     Modified "cleanbatch" so it concatenates all <batchfile>.<pid> files
 **         into one <batchfile>.old file
 **     Cleaned up some of the printf() messages in "src/xmitauth.c" in an
 **         attempt to be more clear
 **     Fixed bug in update_batchfile() where Batchfile.use was improperly
 **         getting set to False when it should be True
 **     Fixed bug in write_link_datafile() where I was calling atof() with
 **         a NULL pointer
 **     Rewrote the "-y" (delay) code, now it gets the article timestamp
 **         and uses that for computing how long to delay for
 **     Removed the LOOKUP_ARTICLE define -- nntplink figures out if it
 **         needs to do the lookup in the history file or not
 **     Modified so when read() returns EINTR, log() isn't called since the
 **         user probably sent a signal (i.e., nightly updates)
 **         --cross@cs.tu-berlin.de (Carsten Rossenhoevel)--
 **     Modified send_news() so the '-y' sleep is done here, before it would
 **         sleep() in parse_entry() -- which meant it would sleep even it
 **         it was only trying to create a batchfile
 **         --cross@cs.tu-berlin.de (Carsten Rossenhoevel)--
 **     Reset Host.connected if send_command senses the connection was closed
 **         --cross@cs.tu-berlin.de (Carsten Rossenhoevel)--
 **     Modified links so if you create a symlink to it called "linksage",
 **         "linksstart" or "linksstop", it will act appropriately
 **         --mrp@itd.adelaide.edu.au (Mark Prior)--
 **     Replaced "set - $options" with "set -- $options" for OSF/1
 **         --mrp@itd.adelaide.edu.au (Mark Prior)--
 **     Take out check for empty batchfile in open_batchfile()
 **         --rmtodd@mailhost.ecn.uoknor.edu (Richard Michael Todd)--
 **     Added a missing "break" to the 'y' case in parseargs.c
 **         --Jean-Marc.Berenguier@univ-compiegne.fr--
 **     Modified "links" so that if you specify "age", it won't HUP any
 **         nntplink processes which are using the "Batchfile" mode
 **         --Christophe.Wolfhugel@grasp.insa-lyon.fr--
 **     NetBSD (along with other BSD's I'm told) claims to be POSIX compliant,
 **         however, it doesn't have a sysconf()
 **         --andrew@werple.apana.org.au (Andrew Herert)--
 **     If "sequent" is defined, then assume that it isn't posix compliant
 **         even if _POSIX_VERSION is defined
 **         --paul@ux1.cso.uiuc.edu (Paul Pomes)--
 **     Added "INSTALL = @INSTALL@" to the Makefile.in
 **         --kieber@sax.sax.de (Ulf Kieber)--
 **     Modified to print PASSFILE instead of "nntp.sys" if fail() is
 **         is call in xmitauth.c
 **         --lindholm@ucs.ubc.ca (George Lindholm)--
 **     Replaced "#elif" with "#else,#if,#endif"
 **         --markb@cccd.edu (Mark Bixby)--
 **         --paul@ux1.cso.uiuc.edu (Paul Pomes)--
 **
 ** 3.2pl1
 **     Modified cleanbatch to check if bfile.<pid>.tmp exists, then check
 **         to make sure that the <pid> process is still running - in case
 **         it crashed
 **     Fixed bug in cleanbatch which could lose batchfiles
 **     Added "-v" option to cleanbatch (see README.CLEANBATCH for info)
 **     Fixed several typos
 **     Added a missing "#" in the links.raw script (only noticed if CNEWS
 **         was defined)
 **     Modified check_batchfile() to only check the return status of
 **         closedir() if VOID_CLOSEDIR isn't defined
 **         --paul@ux1.cso.uiuc.edu (Paul Pomes)--
 **     Modified Makefile.in to use INSTALL_PROGRAM and changed the targe
 **         for install from $(bindir) to $(bindir)/nntplink
 **         --kieber@is2151.inf.tu-dresden.de (Ulf Kieber)--
 **     Fixed bug in my_exit() which used a variable before it had been set
 **         --kieber@is2151.inf.tu-dresden.de (Ulf Kieber)--
 **     Modified cleanbatch-list to be the same format as links-list
 **         --Markus.Zellner@anu.edu.au--
 **
 ** 3.2
 **     Modified "links" so that it will age the "artificial logfile" created
 **         INN for use with "-i logfile", thanks to Jerry Aguirre for the
 **         original concept and code
 **     Modified '-o' so that it DOES update the batchfile
 **     Modified so that if '-o' is specified and send_news() returns an error,
 **         nntplink exits instead of sleeping
 **     Added '-q' option
 **     Added '-k' option
 **     Added "cleanbatch" script to deal with batchfiles which were
 **         created with '-q' option
 **     Removed errmsg() def from strfuns.h
 **     Fixed MAX_NAPTIME
 **     rename <bfile.nntp> to <bfile.pid> if reading from STDIN
 **     Fixed problem with recurring "0"'s at the end of the batchfile
 **     Fixed "Xreplic" so it works now
 **     Fixed problem of not checking for bogus message-id
 **     Switched over to Autoconf
 **     Added "STATS_LOGLEVEL" in config.h to select syslog() level for logging
 **         statistics
 **     If we don't have <values.h>, then try to fake it
 **     Fixed problem with parse_entry not knowing which type of entry it is
 **         parsing -- now passes "entry_type" as a parameter
 **     Fixed loop between update_batchfile() and cleck_sleep() if
 **         Reset_signaled is TRUE
 **         --Christophe.Wolfhugel@grasp.insa-lyon.fr--
 **     Modified to operate in "tail logfile" mode with INN
 **         --jerry@strobe.ATC.Olivetti.Com (Jerry Aguirre)--
 **     Fixed some hard-coded paths in nntplink.man
 **         --kieber@is2161.inf.tu-dresden.de (Ulf Kieber)--
 **     Fixed bug in write_link_datafile()
 **         --rynes@ins.cwru.edu (Edward Rynes)--
 **     Modified to use sysconf() to retrieve dtablesize if on a posix system
 **         --Pekka.Nikander@ajk.tele.fi--
 **     Added delayed Ihave/Sendme
 **         --Christophe.Wolfhugel@grasp.insa-lyon.fr--
 **     Added "links stop" to the links script
 **         --sjr@afterlife.ncsc.mil (Stephen J. Roznowski)--
 ** 
 ** 3.1    -  11-02-92
 **     Changed "-L" so that it is no longer exclusive (i.e., a -L will log
 **         closings, but it will still also allow logging after <n> articles
 **         have been offered.)
 **     Fixed major problem whereby it would get stuck in batchfile mode, i.e.,
 **         it would read the info from <stdin>, write it out to the batchfile,
 **         read it back in from the batchfile and then process it
 **     Modified so that if there is an "error" condition (i.e., timeout, bad
 **         reply to an IHAVE, etc) nntplink closes the connection without
 **         sending a QUIT message.
 **     Fixed problem with writing junk into batchfile
 **     Added code to log the number of remaining articles left whenever HUP or
 **         TERM signals are received (<stdin> and <logfile> modes only)
 **     Added code to remove already sent articles from <batchfile>.nntp
 **         whenever HUP or TERM signals are received (<stdin> and <logfile>
 **         modes only)
 **     Fixed problem with using "-C" in <stdin> mode
 **     Added code to handle Xreplic (protocol extension used by INN to permit
 **         master/slave netnews replication)
 **     Modified "links" to use "echo <blah> | tr -d '\012'"
 **     Modified setsid() so it closes stdin, stdout, and stderr if TIOCNOTTY
 **         isn't defined
 **     Modified so that it doesn't start up if it finds another nntplink
 **         process already running
 **     Fixed problem with overwriting the datafile with bogus offset/inode
 **         info
 **     Moved everything from the "sup" directory into the "extra" directory
 **     Modified so that when it exits it resets <stdin> to the original mode
 **         it was in when it was started
 **     Fixed problem whereby -999 would not get written to the datafile upon
 **         exiting if you used "-L" and the connection happened to be closed 
 **         when you sent a SIGTERM
 **         --per@erix.ericsson.se--
 **     Fixed problem with zero length file being mmap()'ed - this would return
 **         an error and would loop forever
 **         --stevo@elroy.jpl.nasa.gov && tale@uunet.uu.net--
 **     Added linkinfo to the extra directory
 **         --sjr@afterlife.ncsc.mil--
 **     Fixed obscure bug whereby nntplink would be started at bootup and would
 **         have the old pid, therefore it would complain that an nntplink
 **         process is already running and would exit
 **         --per@erix.ericsson.se--
 **     Added C News performance patches
 **         --fulvio@iconet.ico.olivetti.com--
 **     Fixed bug in article.c whereby open_article() didn't make sure that
 **         the article wasn't already open
 **         --taka@fxis.fujixerox.co.jp--
 **     Replaced arg after "NNTP" with SOCK_STREAM in dnet_conn() call in
 **         remote.c
 **         --thomas@mipsbx.lkg.dec.com--
 **     Replaced "setjmp/longjmp" with "_setjmp/_longjmp", and removed
 **         (re)setting SIGALRM after each alarm() call -- does it once at
 **         startup since it is never used elsewhere
 **         --david@elroy.jpl.nasa.gov && stevo@elroy.jpl.nasa.gov--
 **     Removed xfer stats since they can be calculated externally and added
 **         number of connections to stats
 **         --leres@ee.lbl.gov--
 **     Changed "LOG_ERROR" to "DO_LOG_ERROR"
 **         --mrp@itd.adelaide.edu.au--
 **     Fixed bug in article.c whereby it could lose articles if you used
 **         batchfile input w/o mesg-id's in the batchfile
 **         --per@erix.ericsson.se--
 **     Fixed bug in setupproc.c whereby it ignored HAVE_SETPGRP_NOARGS
 **         --doug@cc.ysu.edu--
 **     Fixed bug in history.c
 **         --per@erix.ericsson.se && bdale@col.hp.com--
 **     Fixed bug with syslog and "%" in messages
 **         --leres@ee.lbl.gov--
 **     Fixed bug in tcpconn.c
 **         --james@raid.dell.com--
 **     Modified "links" to go ahead and restart nntplink if there is a
 **         bad pid in the datafile
 **         -per@erix.ericsson.se--
 ** 
 ** 
 ** 3.0.2  -  12-15-91
 **     Fixed bug with <stdin> code
 **         --mcooper@usc.edu--
 **     Fixed bug with file creation mode
 **         --mcooper@usc.edu--
 **     Fixed bug which caused all non three column input files to drop on
 **         the floor
 **         --rob@violet.berkeley.edu--
 **     Modified "links" to read the config script when running C News
 **         --Mark-Moraes@deshaw.com--
 **     Fixed the one-shot option to work with logfiles
 **     Modified so that it close/reopens the fake syslog when sent a HUP
 **         signal
 ** 
 ** 
 ** 3.0.1  -  11-11-91
 **     Fixed many small bugs, thanks to:
 **         --Mark-Moraes@deshaw.com (Mark Moraes)--
 **         --fletcher@cs.utexas.edu (Fletcher Mattox)--
 **         --brendan@cs.widener.edu (Brendan Kehoe)--
 **         --per@erix.ericsson.se (Per Hedeland)--
 **         --andy@jhunix.hcf.jhu.edu (Andy Poling)--
 **         --dpk@morgan.com (Doug Kingston)--
 **     Changed the way nntplink dissociates itself from the controlling
 **         terminal
 **         --Mark-Moraes@deshaw.com--
 **     Added the "which port" option
 **         --asp@uunet.uu.net--
 **     Changed "Open article first" from compile time to run time option
 **     Added the "Log closings" option
 **     Renamed several options
 ** 
 ** 3.0    -  05-20-91
 **     Almost complete rewrite (95% of the code is brand new)
 **     Added support for DKHOST
 **         --tim.g.thompson@att.com--
 ** 
 ** 2.2.1  -  03-05-91
 **     Fixed a bug in the stats reporting
 **         --tale@cs.rpi.edu--
 **     Fixed naptime code
 **         --jerry@olivey.atc.olivetti.com--
 **     Removed CNEWS_BATCHDIR definition, now it automagically discovers
 **         if you are using CNEWS batchdir
 **         --Mark-Moraes@deshaw.com--
 **     Changed name of read_link_data to update_link_data since it also writes
 **         the file
 **         --Mark-Moraes@deshaw.com--
 **     Fixed a typo in remote.c
 **         --stevo@elroy.jpl.nasa.gov--
 **     Fixed the makefile
 **         --rsalz@bbn.com--
 **     Now writes correct pid to link file
 **
 ** 2.2    -  02-10-91
 **     Added B News support for the -X option
 **         --andy@jhunix.hcf.jhu.edu && fletcher@cs.utexas.edu--
 **     fakesyslog() uses SIGUSR1 to resetlog()
 **         --andy@jhunix.hcf.jhu.edu--
 **     changed the getdtablesize() line
 **         --rsalz@bbn.com--
 **     fixed the "-B","-C","-L" options to work the way they're supposed to
 **     updated description of "-B" vs "-C" in the man page and conf.h
 ** 
 ** 2.1    -  12-14-90
 **     Added MMAP definition
 **         --stevo@elroy.jpl.nasa.gov--
 **     Added FAKESYSLOG code from the nntp code
 **         --tim.g.thompson@att.com--
 **     Added "auth" code from the original nntp 1.5.10 code
 **     Syslogs a message if unable to connect for <n> hours
 **     Puts article in a batch.fail file after <n> attempts to send it fail
 **     Syslogs a message explaining why the article failed
 **     Added CNEWS_HACK, if def then nntplink only watches for a .nntp file
 **     Changed "Improper response to..." to include what the response was
 **     Store the pid into batch.link, -999 if not running
 ** 
 ** 2.0.3  -  04-07-90
 **     New CNEWS_BATCHDIR definition (see conf.h for explanation)
 **     Updated the man page to be more current.
 **     Fixed various misc small bugs.
 ** 
 ** 2.0.2  -  04-05-90
 **     Added HP/UX 6.0 support
 **         --icsu6000@cs.montana.edu--
 ** 
 ** 2.0.1  -  04-04-90
 **     Cleaned up some bugs that appeared when compiled without CNEWS.
 ** 
 ** 2.0    -  04-02-90
 **     Added -X and -E options
 **     Modified so that it only opens the article only when necessary
 **     Changes working directory to SPOOL_DIR now
 **     Improved Makefile
 **         --asp@uu.uu.net && lamy@cs.utoronto.edu--
 ** 
 ** 1.10.6 -  01-14-90
 **     Prints out config info on startup now
 ** 
 ** 1.10.5 -  11-27-89
 **     Split up nntplink.c to several smaller files
 **     Message-id is now save in rewrite()
 **     Code to check C-news .vs. B-news (spots cfg errors)
 ** 
 ** 1.10.4 -  11-23-89
 **     Added -I (idling time out)
 **         --lamy@cs.utoronto.edu--
 ** 
 ** 1.10.3 -  11-20-89
 **     Removed one-shot feature-- doesn't apply.
 **     Added -S option
 **         --coolidge@cs.uiuc.edu--
 ** 
 ** 1.10.2 -  11-19-89
 **     Fixes major bug (dropped articles) --- linked lists removed.
 **     Added -L and -C options, reorganized stats gathering.
 **         --lamy@cs.utoronto.edu--
 **
 ** 1.10.0 -  11-11-89
 **     Initial public release
 ** 
 ** 1.01.4 -  11-10-89
 **     Added HP/UX support.
 **         --icsu6000@cs.montana.edu--
 ** 
 ** 1.01.3 -  11-08-89
 **     Fix dprintf bug (big bug)
 **         --fletcher@cs.utexas.edu--
 ** 
 ** 1.01.2 -  11-05-89
 **     Removed -x option.  It is always set now.
 **     Very small change to safecopy().
 ** 
 ** 1.01.1 -  11-03-89
 **     Cnews batchfile compatibility
 **         --coolidge@cs.uiuc.edu--
 ** 
 ** 1.01.0 -  11-02-89
 **     SVR3 compatible?
 ** 
 **/

#define RELEASE			"3.3"
#define PATCHLEVEL		"2"
#define DATE			"22-Jun-94"
#define DATAFILE_VERSION	3.0
